VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Books"
   ClientHeight    =   3600
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6975
   LinkTopic       =   "Form1"
   ScaleHeight     =   3600
   ScaleWidth      =   6975
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print"
      Height          =   375
      Left            =   3000
      TabIndex        =   1
      Top             =   2040
      Width           =   855
   End
   Begin MSFlexGridLib.MSFlexGrid flxData 
      Height          =   1695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2175
      _ExtentX        =   3836
      _ExtentY        =   2990
      _Version        =   393216
      AllowUserResizing=   1
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const HGAP = 60
Private Const VGAP = 30
Private Const INCH As Single = 1440#

' Print a MSFlexGrid control's data across multiple pages vertically and horizontally.
Private Sub PrintFlexGridMultiPage(ByVal flx As MSFlexGrid, ByVal l_margin As Single, ByVal t_margin As Single, ByVal r_margin As Single, ByVal b_margin As Single, ByVal page_x As Single, ByVal page_y As Single)
Dim r As Integer
Dim page_r As Integer

    ' Print the rows.
    r = 0
    page_r = 0
    Do While r < flx.Rows
        ' Print the next set of rows.
        PrintFlexGridRows flx, r, _
            l_margin, t_margin, r_margin, b_margin, _
            page_x, page_y, page_r
        page_r = page_r + 1
    Loop
End Sub
' Print the horizontal pages for the rows start_row through stop_row
' starting with column start_col.
' Leave start_col pointing to the first column after those printed.
Private Sub PrintFlexGridRowColumns(ByVal flx As MSFlexGrid, ByVal start_row As Integer, ByVal stop_row As Integer, ByRef start_col As Integer, ByVal l_margin As Single, ByVal t_margin As Single, ByVal r_margin As Single, ByVal b_margin As Single, ByVal page_x As Single, ByVal page_y As Single, ByVal page_r As Integer, ByVal page_c As Integer)
Dim xmax As Single
Dim ymax As Single
Dim r As Integer
Dim c As Integer
Dim stop_col As Integer
Dim x As Single
Dim y As Single
Dim page_txt As String

    ' Print the page number.
    page_txt = "Page (" & Format$(page_r) & ", " & Format$(page_c) & ")"
    Printer.CurrentX = page_x - Printer.TextWidth(page_txt)
    Printer.CurrentY = page_y
    Printer.Print page_txt;
    ' Debug.Print page_txt & ": ";

    With flxData
        ' See which columns will fit on this page.
        ' Start with the first column.
        stop_col = start_col
        xmax = l_margin + .ColWidth(stop_col) + 2 * HGAP
        Do
            If stop_col + 1 >= .Cols Then Exit Do
            If xmax + .ColWidth(stop_col + 1) + 2 * HGAP > r_margin Then Exit Do
            xmax = xmax + .ColWidth(stop_col + 1) + 2 * HGAP
            stop_col = stop_col + 1
        Loop

        ' Print the cells that fit.
        ' Debug.Print start_row, stop_row, start_col, stop_col
        y = t_margin
        For r = start_row To stop_row
            x = l_margin
            For c = start_col To stop_col
                '(Debug) Printer.Circle (x, y), 40
                'Debug.Print "    (" & x + HGAP & ", " & y + VGAP & ")"
                Printer.CurrentX = x + HGAP
                Printer.CurrentY = y + VGAP
                Printer.Print .TextMatrix(r, c);
                x = x + .ColWidth(c) + 2 * HGAP
            Next c
            y = y + .RowHeight(r) + 2 * VGAP
        Next r

        ' Print a grid.
        ymax = y
        y = t_margin
        For r = start_row To stop_row
            '(Debug) Printer.Line (l_margin, y)-Step(60, 60), , B
            Printer.Line (l_margin, y)-(xmax, y)
            y = y + .RowHeight(r) + 2 * VGAP
        Next r
        Printer.Line (l_margin, y)-(xmax, y)

        x = l_margin
        For c = start_col To stop_col
            '(Debug) Printer.Line (x, t_margin)-Step(60, 60), , B
            Printer.Line (x, t_margin)-(x, ymax)
            x = x + .ColWidth(c) + 2 * HGAP
        Next c
        Printer.Line (x, t_margin)-(x, ymax)
    End With

    ' Finish this page.
    Printer.NewPage

    ' Set start_col for return.
    start_col = stop_col + 1
End Sub
' Print the horizontal pages for the next set of rows that will
' fit on a page vertically. Start with row start_row.
' Leave start_row pointing to the first row after those printed.
Private Sub PrintFlexGridRows(ByVal flx As MSFlexGrid, ByRef start_row As Integer, ByVal l_margin As Single, ByVal t_margin As Single, ByVal r_margin As Single, ByVal b_margin As Single, ByVal page_x As Single, ByVal page_y As Single, ByVal page_r As Integer)
Dim ymax As Single
Dim c As Integer
Dim stop_row As Integer
Dim page_c As Integer

    With flxData
        ' See which rows will fit on this page.
        ' Start with the first row.
        stop_row = start_row
        ymax = t_margin + .RowHeight(stop_row) + 2 * VGAP
        Do
            If stop_row + 1 >= .Rows Then Exit Do
            If ymax + .RowHeight(stop_row + 1) + 2 * VGAP > b_margin Then Exit Do
            ymax = ymax + .RowHeight(stop_row + 1) + 2 * VGAP
            stop_row = stop_row + 1
        Loop

        ' Print horizontal groups of pages.
        c = 0
        page_c = 0
        Do While c < .Cols
            PrintFlexGridRowColumns flx, start_row, stop_row, c, _
                l_margin, t_margin, r_margin, b_margin, _
                page_x, page_y, page_r, page_c
            page_c = page_c + 1
        Loop
    End With

    ' Set start_row and page_r for return.
    page_r = page_r + 1
    start_row = stop_row + 1
End Sub
Private Sub SetMargins(ByRef l_margin As Single, ByRef t_margin As Single, ByRef r_margin As Single, ByRef b_margin As Single, ByRef page_x As Single, ByRef page_y As Single)
    l_margin = Printer.ScaleLeft + 0.5 * INCH
    t_margin = Printer.ScaleTop + 0.5 * INCH
    r_margin = Printer.ScaleLeft + Printer.ScaleWidth - 0.75 * INCH
    b_margin = Printer.ScaleTop + Printer.ScaleHeight - 0.5 * INCH
    page_x = Printer.ScaleLeft + Printer.ScaleWidth - 0.25 * INCH
    page_y = t_margin
End Sub

Private Sub cmdPrint_Click()
Dim l_margin As Single
Dim r_margin As Single
Dim t_margin As Single
Dim b_margin As Single
Dim page_x As Single
Dim page_y As Single

    Screen.MousePointer = vbHourglass
    DoEvents

    ' Set the printer's font to match the control's.
    With Printer.Font
        .Name = flxData.Font.Name
        .Size = flxData.Font.Size
    End With

    SetMargins l_margin, t_margin, r_margin, b_margin, page_x, page_y
    PrintFlexGridMultiPage flxData, _
        l_margin, t_margin, r_margin, b_margin, _
        page_x, page_y

    Printer.EndDoc

    Screen.MousePointer = vbDefault
End Sub
Private Sub Form_Load()
Const H_REPEATS As Integer = 3
Const V_REPEATS As Integer = 10
Dim db_file As String
Dim statement As String
Dim conn As ADODB.Connection
Dim rs As ADODB.Recordset
Dim c As Integer
Dim r As Integer
Dim txt As String
Dim col_num As Integer
Dim col_wid() As Single
Dim field_wid As Single
Dim h As Integer
Dim v As Integer

    ' Prepare the grid.
    With flxData
        ' Use a font that is likely to be on the printer.
        .Font.Name = "Times New Roman"
        .Font.Size = 10

        .Rows = 2
        .FixedRows = 1
        .FixedCols = 0
        .Rows = 1
        .Cols = 2 * H_REPEATS
        .SelectionMode = flexSelectionByRow
        For h = 0 To H_REPEATS - 1
            .TextMatrix(0, 2 * h) = "(0, " & Format$(2 * h) & ") Books I Need"
            .TextMatrix(0, 2 * h + 1) = "(0, " & Format$(2 * h + 1) & ") URL"
        Next h
    End With

    ' Get the data.
    db_file = App.Path
    If Right$(db_file, 1) <> "\" Then db_file = db_file & "\"
    db_file = db_file & "books.mdb"

    ' Open a connection.
    Set conn = New ADODB.Connection
    conn.ConnectionString = _
        "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & db_file & ";" & _
        "Persist Security Info=False"
    conn.Open

    ' Select the data.
    statement = "SELECT * FROM Books ORDER BY Title"

    ' Get the records.
    Set rs = conn.Execute(statement, , adCmdText)

    ' Display the values for each row.
    ReDim col_wid(0 To H_REPEATS * rs.Fields.Count - 1)
    With flxData
        col_wid(0) = TextWidth(.TextMatrix(0, 0))

        Font.Name = flxData.Font.Name
        Font.Size = flxData.Font.Size

        r = 1
        For v = 1 To V_REPEATS
            rs.MoveFirst
            Do While Not rs.EOF
                .Rows = .Rows + 1
                For h = 0 To H_REPEATS - 1
                    For c = 0 To rs.Fields.Count - 1
                        col_num = c + h * rs.Fields.Count
                        txt = "(" & Format$(r) & ", " & _
                            Format$(col_num) & ") " & _
                            rs.Fields(c)
                        .TextMatrix(r, col_num) = txt
                        If col_wid(col_num) < TextWidth(txt) Then col_wid(col_num) = TextWidth(txt)
                    Next c
                Next h

                rs.MoveNext
                r = r + 1
            Loop
        Next v

        ' Size the columns.
        For c = 0 To UBound(col_wid)
            .ColWidth(c) = col_wid(c) + 120
            .ColAlignment(c) = flexAlignLeftCenter
        Next c
    End With

    ' Close the recordset and connection.
    rs.Close
    conn.Close

    Printer.Orientation = vbPRORLandscape
End Sub
Private Sub Form_Resize()
Dim hgt As Single
Dim x As Single

    hgt = ScaleHeight - 120 - cmdPrint.Height
    If hgt < 120 Then hgt = 120

    flxData.Move 0, 0, ScaleWidth, hgt

    x = (ScaleWidth - cmdPrint.Width) / 2
    cmdPrint.Move x, flxData.Top + flxData.Height + 60
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Printer.Orientation = vbPRORPortrait
End Sub


